<?php

  if (isset($_POST['show_add_donation'])) {
    set_last_selected("area_id", $_POST['area_id']);
    $area_id = $_POST['area_id'];
    show_new_donation_form($area_id);
  }
  else if (isset($_POST['add_donation'])) {
    set_last_selected("area_id", $_POST['area_id']);
    $id = add_donation();
    if ($id !== false) {
      echo "<p>Donation recorded.</p>\n";
      $parameters = array("id", $id);
    }
  }
  else if (isset($_POST['update_donation'])) {
    list($ignored, $id, $args) = parse_parameters($parameters);
    $q = new DonationQuery;
    $donation = $q->findOneById($id);
    if ($donation) {
      if (update_donation($donation) !== false) {
        echo "<p>Updated donation.</p>\n";
        $parameters = array("id", $donation->getId());
      }
    }
    else {
      echo "<p>No such contact!</p>\n";
    }
  }
  else if ($_POST['show_in_area']) {
    set_last_selected("area_id", $_POST['area_id']);
    $q = new AreaQuery;
    $area = $q->findOneById($_POST['area_id']);
    /* XXX: Function to build URL because we need to set a class in links. */
    header(sprintf("Location: http%s://%s/%s/in/area/%s/%d", ($_SERVER['HTTPS']) ? "s" : "", $_SERVER['HTTP_HOST'], $module, urlencode($area->getName()), $_POST['area_id']));
    exit;
  }
  else if ($_POST['show_in_city']) {
    set_last_selected("city_id", $_POST['city_id']);
    $q = new CityQuery;
    $city = $q->findOneById($_POST['city_id']);
    header(sprintf("Location: http%s://%s/%s/in/city/%s/%d", ($_SERVER['HTTPS']) ? "s" : "", $_SERVER['HTTP_HOST'], $module, urlencode($city->getName()), $_POST['city_id']));
    exit;
  }

  function show_donations($contact_ids = null, $hub_ids = null) {
    list($first_page, $per_page) = pagination();
    $q = new DonationQuery;
    if (isset($contact_ids)) $q->filterByContactId($contact_ids);
    if (isset($hub_ids)) $q->filterByHubId($hub_ids);
    $donations = $q->orderByDate('desc')->orderById('desc')->paginate($first_page, $per_page);
    if (count($donations)) {
      foreach ($donations as $donation) {
        echo "<br>\nDonation " . $donation->getStrongLink($donation->getId()) . ": " . get_donation_displayname($donation);

        /* XXX: Should pull from query. */
        $q = new ContactQuery;
        $contact = $q->findOneById($donation->getContactId());
        if ($contact) echo " from " . $contact->getLink();

        $q = new HubQuery;
        $hub = $q->findOneById($donation->getHubId());
        if ($hub) {
          echo " to " . $hub->getLink();
          $area = get_hub_area($hub);
          if ($area) {
            echo " in " . $area->getLink();
            $city = get_area_city($area);
            if ($city) echo ", " . $city->getLink(get_city_displayname($city));
          }
        }
        if (check_admin(1)) {
          echo " " . $donation->getDeleteLink();
        }
      }
      show_pagination($donations);
    }
    else echo " none";
  }

  function show_city_donations($city_name, $city_id = null) {
    if (isset($city_id)) $city = get_city_by_id($city_id);
    else if ($city_name) $city = get_city_by_name($city_name);
    if ($city) {
      $hubs = get_city_hubs($city->getId());
      $hub_ids = array();
      foreach ($hubs as $hub) $hub_ids[] = $hub->getId();

      echo "<p>Donations in city " . $city->getLink(get_city_displayname($city)) . ":";
      return show_donations(null, $hub_ids);
    }
    else echo "<p>No such city!</p>\n";
  }

  function show_contact_donations($contact_name, $contact_id = null) {
    if (isset($contact_id)) $contact = get_contact_by_id($contact_id);
    else if ($contact_name) $contact = get_contact_by_name($contact_name);
    if ($contact) {
      echo "<p>Donations from contact " . $contact->getLink() . ":";
      return show_donations($contact->getId());
    }
    else echo "<p>No such contact!</p>\n";
  }

  function show_hub_donations($hub_name, $hub_id = null) {
    if (isset($hub_id)) $hub = get_hub_by_id($hub_id);
    else if ($hub_name) $hub = get_hub_by_name($hub_name);
    if ($hub) {
      echo "<p>Donations to hub " . $hub->getLink() . ":";
      return show_donations(null, $hub->getId());
    }
    else echo "<p>No such hub!</p>\n";
  }

  function show_area_donations($area_name, $area_id = null) {
    if (isset($area_id)) $area = get_area_by_id($area_id);
    else if ($area_name) $area = get_area_by_name($area_name);
    if ($area) {
      $hubs = get_area_hubs($area->getId());
      $hub_ids = array();
      foreach ($hubs as $hub) $hub_ids[] = $hub->getId();

      echo "<p>Donations in area " . $area->getLink() . ":";
      return show_donations(null, $hub_ids);
    }
    else echo "<p>No such area!</p>\n";
  }

  function show_donation_areas_form($city_id = null) {
    $areas = get_city_areas($city_id);
    if (! count($areas)) {
      echo "<p>No <a href=\"/area\">areas</a>!</p>\n";
      return;
    }

    form("noprint standout");
    $candidates = array();
    foreach ($areas as $area) {
      if (! count(get_area_hubs($area->getId()))) continue;
      $candidates[] = $area;
    }
    if (! count($candidates)) return;

    echo "<p>Show donations in area\n";
    echo "<select name=\"area_id\">\n";
    foreach ($candidates as $area) {
      option("area_id", $area->getId(), get_area_displayname($area));
    }
    echo "</select>\n";
    submit("show_in_area", "Show");
  }

  function show_donation_cities_form($city_id = null) {
    $q = new CityQuery;
    $cities = $q->orderByName()->find();

    if (! count($cities)) {
      echo "<p>No <a href=\"/city\">cities</a>!</p>\n";
      return;
    }

    $candidates = array();
    foreach ($cities as $city) {
      if (! count(get_city_hubs($city->getId()))) continue;
      $candidates[] = $city;
    }
    if (! count($candidates)) return;

    echo "<p>Show donations in city\n";
    echo "<select name=\"city_id\">\n";
    foreach ($candidates as $city) {
      option("city_id", $city->getId(), get_city_displayname($city), $city_id);
    }
    echo "</select>\n";
    submit("show_in_city", "Show");
  }

  function show_donation_forms($city_id) {
    form("noprint standout");
    show_donation_areas_form($city_id);
    show_donation_cities_form($city_id);
    end_form();
  }

  function show_donation_form($donation = null, $area_id = null) {
    if (! $donation) $donation = new Donation;

    /* Date. */
    echo "<tr>\n";
    echo "  <td>Date</td>\n";
    echo "  <td>"; show_date_form("date", $donation->getDate()); echo "</td>\n";
    echo "</tr>\n";

    /* Contact. */
    echo "<tr>\n";
    echo "  <td>Donor</td>\n";
    echo "  <td><select name=\"contact_id\">\n";
    $contacts = get_area_donors();
    foreach ($contacts as $contact) {
      option("contact_id", $contact->getId(), $contact->getDisplayname(), $donation->getContactId());
    }
    echo "</select></td>\n";
    echo "</tr>\n";

    /* Hub. */
    echo "<tr>\n";
    echo "  <td>Hub</td>\n";
    echo "  <td><select name=\"hub_id\">\n";
    $hubs = get_area_hubs();
    foreach ($hubs as $hub) {
      option("hub_id", $hub->getId(), $hub->getDisplayname(), $donation->getHubId());
    }
    echo "</select></td>\n";
    echo "</tr>\n";

    /* Quantity. */
    echo "<tr>\n";
    echo "  <td>Quantity (kg)</td>\n";
    echo "  <td>"; input("quantity", sprintf("%0.2f", $donation->getQuantity() / 1000)); echo "</td>\n";
    echo "</tr>\n";
  }

  function show_new_donation_form($area_id = null) {
    if (! check_admin(1)) return;

    $area = get_area_by_id($area_id);
    if (! count($area)) {
      echo "<p>No such <a href=\"/area\">area</a>!</p>\n";
      return;
    }

    form();
    echo "<p>Record a donation:</p>\n";

    echo "<table>\n";
    show_donation_form(null, $area_id);

    echo "<tr>\n";
    echo "  <td colspan=2>"; submit("add_donation", "Record"); echo "</td></tr>\n";
    echo "</tr>\n";
    echo "</table>\n";
    end_form();
  }

  function show_hub_donation_form($hub) {
    if (! check_admin(1)) return;

    $area = get_hub_area($hub);
    if (! $area) {
      echo "<p>No such <a href=\"/area\">area</a>!</p>\n";
      return;
    }

    $donation = new Donation;
    $donation->setHubId($hub->getId());

    form();
    echo "<p>Record a donation:</p>\n";

    echo "<table>\n";
    show_donation_form($donation, $area->getId());

    echo "<tr>\n";
    echo "  <td colspan=2>"; submit("add_donation", "Record"); echo "</td></tr>\n";
    echo "</tr>\n";
    echo "</table>\n";
    end_form();
  }

  function show_add_new_donation_form() {
    if (! check_admin(1)) return;

    /* We intentionally hide areas with no hubs. */
    $areas = get_city_areas_with_hubs();
    if (! count($areas)) {
      echo "<p>Can't record any donations until at least one <a href=\"/area\">area</a> has a <a href=\"/hub\">hub</a>!</p>\n";
      return;
    }

    form("noprint standout");
    echo "<p>Record a donation in <select name=\"area_id\">\n";
    foreach ($areas as $area) {
      option("area_id", $area->getId(), get_area_displayname($area));
    }
    echo "</select>";
    submit("show_add_donation", "Proceed");
    echo "</p>\n";
    end_form();
  }

  function update_donation(&$donation, $new = false) {
    $date = $_POST['date'];
    $contact_id = $_POST['contact_id'];
    $hub_id = $_POST['hub_id'];
    $quantity = $_POST['quantity'];

    if (! $date) $date = time();
    /* XXX: check date */

    $contact = get_contact_by_id($contact_id);
    if (! $contact) {
      echo "<p>Invalid contact!</p>\n";
      return false;
    }

    $hub = get_hub_by_id($hub_id);
    if (! $hub) {
      echo "<p>Invalid hub!</p>\n";
      return false;
    }

    if (! is_numeric($quantity)) {
      echo "<p>Invalid quantity!</p>\n";
      return false;
    }

    $donation->setDate($date);
    $donation->setContactId($contact_id);
    $donation->setHubId($hub_id);
    $donation->setQuantity($quantity * 1000);

    try {
      $donation->save();
    }
    catch (Exception $e) {
      if ($new) echo "<p>Error recording donation.</p>\n";
      else echo "<p>Error updating donation.</p>\n";
      return false;
    }

    return true;
  }

  function add_donation() {
    if (! check_admin(1, "record a donation")) return;

    $donation = new Donation;
    if (! update_donation($donation, true)) return false;
    return $donation->getId();
  }

  function confirm_delete_donation($id = null) {
    if (! check_admin(1, "delete a donation")) return;

    if (isset($id)) $donation = get_donation_by_id($id);
    if (! $donation) return false;

    echo "<h3>Confirm deletion</h3>\n";
    echo "<p>You must confirm deletion of donation $id: " . $donation->getDeleteLink(true) . "</p>\n";
  }

  function delete_donation($id = null) {
    if (! check_admin(1, "delete a donation")) return;

    if (isset($id)) $donation = get_donation_by_id($id);
    if (! $donation) return false;

    try {
      $donation->delete();
      echo "<p>Deleted donation.</p>\n";
    }
    catch (Exception $e) {
      echo "<p>Error deleting donation $id!</p>\n";
      return false;
    }

    return true;
  }

  function show_donation(&$id = null) {
    if (isset($id)) $donation = get_donation_by_id($id);
    if (! $donation) return;

    form();
    echo "<p>Donation <span class=\"strong\">" . $donation->getId() . "</span>";
    if (check_admin(1)) {
      echo " " . $donation->getDeleteLink();
    }
    echo ": ";
    echo "\n</p>";

    echo "<table>\n";
    show_donation_form($donation);

    if (check_admin(1)) {
      echo "<tr>\n";
      echo "  <td colspan=2>";
      submit("update_donation", "Update");
      echo "</td>\n";
      echo "</tr>\n";
    }

    echo "</table>\n";
    end_form();
  }

  if (count($parameters)) {
    if ($parameters[0] == "in") {
      /* /donation/in/area/Romsey+Town/1 */
      switch ($parameters[1]) {
        case "area":
          $area_id = $parameters[3];
          $_POST['area_id'] = $area_id;
          $q = new AreaQuery;
          $area = $q->findOneById($area_id);
          $city = get_area_city($area);
          if ($city) $city_id = $city->getId();
          show_area_donations($parameters[2], $area_id);
        break;

        case "city":
          $city_id = $parameters[3];
          $_POST['city_id'] = $city_id;
          $q = new CityQuery;
          $city = $q->findOneById($city_id);
          show_city_donations($parameters[2], $city_id);
        break;
      }
    }
    else if ($parameters[0] == "from") {
      /* /donation/from/contact/Iain+Patterson/4 */
      switch ($parameters[1]) {
        case "contact":
          $contact_id = $parameters[3];
          $q = new ContactQuery;
          $contact = $q->findOneById($contact_id);
          show_contact_donations($parameters[2], $contact_id);
        break;
      }
    }
    else if ($parameters[0] == "to") {
      /* /donation/to/hub/Cambridge+Community+Church/1 */
      switch ($parameters[1]) {
        case "hub":
          $hub_id = $parameters[3];
          $q = new HubQuery;
          $hub = $q->findOneById($hub_id);
          show_hub_donations($parameters[2], $hub_id);
        break;
      }
    }
    else if ($parameters[0] == "record") {
      if ($parameters[1] == "to") {
        if ($parameters[2] == "hub") {
          if ($parameters[4]) $hub = get_hub_by_id($parameters[4]);
          if (! $hub) $hub = get_hub_by_name(urldecode($parameters[3]));
          if ($hub) show_hub_donation_form($hub);
        }
      }
    }
  }
  list($ignored, $id, $args) = parse_parameters($parameters);
  //echo "<p>$name($id) " . print_r($args, true) . "</p>\n";
  if (count($args)) {
    switch ($args[0]) {
      case "delete":
        confirm_delete_donation($id);
      break;

      case "confirmdelete":
        delete_donation($id);
      break;
    }
  }
  else if (isset($id)) show_donation($id);

  show_donation_forms($city_id);
  show_add_new_donation_form($city_id);

?>
