<?php

  function form($classes = null, $action = null) {
    if (is_null($classes)) $classes = array();
    else if (! is_array($classes)) $classes = explode('/\s+/', $classes);
    if (! isset($action)) $action = $_SERVER['REQUEST_URI'];
    echo "<form ";
    if (count($classes)) printf("class=\"%s\" ", implode(" ", $classes));
    echo "method=\"POST\" action=\"$action\">\n";
  }

  function end_form() {
    echo "</form>\n";
  }

  function input($name, $value = null, $type = null) {
    echo "<input name=\"$name\"";
    if (isset($type)) echo " type=\"$type\"";
    if (isset($value)) echo " value=\"$value\"";
    else echo " value=\"" . $_POST[$name] . "\"";
    echo ">";
  }

  function hidden($name, $value = null) {
    return input($name, $value, "hidden");
  }

  function submit($name, $value = null) {
    return input($name, $value, "submit");
  }

  function textarea($name, $value = null) {
    $id = "textarea_$name";
    echo "<textarea id=\"$id\" name=\"$name\" cols=30>";
    if (isset($value)) echo $value;
    else echo $_POST[$name];
    echo "</textarea>";
    echo "<script>\n  $(function() {\n";
    echo "    $(\"#$id\").autosize();\n";
    echo "  });</script>";
  }

  function option($select, $value, $text, $selected = null) {
    echo "  <option value=\"$value\"";
    if (! isset($selected)) $selected = $_POST[$select];
    if (! isset($selected)) $selected = get_last_selected($select);
    if ($value == $selected) echo " selected";
    echo ">$text\n";
  }

  function datepicker($name, $value = null, $past = true, $past_picker = null, $future = true, $future_picker = null) {
    $id = "datepicker_$name";
    echo "<script>\n  $(function() {\n";
    echo "    $(\"#$id\").datepicker({\n";
    /*
      If this is the "to" picker in a date range, restrict the end date of the
      "from" picker to be the date selected by this picker.
    */
    if (isset($past_picker)) {
      echo "      onClose: function(selectedDate) {\n";
      echo "        $(\"#datepicker_$past_picker\").datepicker(\"option\", \"maxDate\", selectedDate);\n";
      echo "      },\n";
    }
    /*
      If this is the "from" picker in a date range, restrict the start date of
      the "to" picker to be the date selected by this picker.
    */
    if (isset($future_picker)) {
      echo "      onClose: function(selectedDate) {\n";
      echo "        $(\"#datepicker_$future_picker\").datepicker(\"option\", \"minDate\", selectedDate);\n";
      echo "      },\n";
    }
    echo "      changeMonth: true,\n";
    echo "      changeYear: true,\n";
    echo "      dateFormat: 'yy-mm-dd',\n";
    /* Are we allowed to show dates earlier than today? */
    if (! $past) echo "      minDate: 0,\n";
    /* Are we allowed to show dates later than today? */
    if (! $future) echo "      maxDate: 0,\n";
    echo "      showButtonPanel: true\n";
    echo "    });\n  });</script>";
    echo "<input name=\"$name\" id=\"$id\"";
    echo " maxlength=10 size=10";
    if (isset($value)) echo " value=\"$value\"";
    else echo " value=\"" . $_POST[$name] . "\"";
    echo "><em class=\"small\">(Y-m-d)</em>";
  }

?>
